<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset=utf-8>
	<meta name="viewport" content="width=device-width, initial-scale=1.0">

	<title> TicTacToe game </title>

	<script
		src="https://code.jquery.com/jquery-2.2.4.min.js"
		integrity="sha256-BbhdlvQf/xTY9gja0Dq3HiwQF8LaCRTXxZKRutelT44="
		crossorigin="anonymous"
	></script>

	<link
		rel="stylesheet"
		href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css"
		integrity="sha384-1q8mTJOASx8j1Au+a5WDVnPi2lkFfwwEAa8hDDdjZlpLegxhjVME1fgjWPGmkzs7"
		crossorigin="anonymous"
	>

	<script
		src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js"
		integrity="sha384-0mSbJDEHialfmuBBQP6A4Qrprq5OVfW37PRR3j5ELqxss1yVqOtnepnHVP9aJ7xS"
		crossorigin="anonymous"
	></script>

	<script>
		$(document).ready(function(){
			$("#x").hide();
			$("#o").hide();
			$("#again").hide();
			$("#field").hide();


			var isSecure = false;
			if (location.protocol == "https:"){
				isSecure = true;
			}
			var url = (isSecure ? "wss://" : "ws://") + location.hostname + ":8080/";

			var socket = new WebSocket(url);
			socket.onopen = function() {
				$("#x").show();
				$("#o").show();
			};

			socket.onclose = function(event) {
				$("#x").hide();
				$("#o").hide();
				$("#again").show();
			};

			socket.onmessage = function(event) {
				data = JSON.parse(event.data);
				if (data.type == "field"){
					$("#field").show();

					jQuery.fn.getCell = function(x,y){
						return jQuery( this[0].rows[x].cells[y]);
					};

					for (var i = 0; i < 9; i++) {
						var col = i % 3;
						var row = (i / 3) >> 0;
						$('#field').getCell(row,col).html(data.field[i]);
					}
				}
				if (data.type == "state"){
					if (data.state == "gameOver"){
						$('#status').html("Game over!");
						socket.close();
					}
					if (data.state == "userMove"){
						$('#status').html("Your turn");
					}
					if (data.state == "aiMove"){
						$('#status').html("Waiting...");
					}
				}
			};

			socket.onerror = function(error) {
				$("#x").hide();
				$("#o").hide();
				$("#again").show();
			};

			$("td").click(function(){
				var col = $(this).parent().children().index($(this));
				var row = $(this).parent().parent().children().index($(this).parent());
				var pos = row*3 + col + 1;
				var raw = {type: "move", position: pos };
				var data = JSON.stringify(raw);
				socket.send(data);
			});

			$("#x").click(function(){
				var raw = { type: "login", team: "x"};
				var data = JSON.stringify(raw);
				socket.send(data);
				$("#x").hide();
				$("#o").hide();
			});

			$("#o").click(function(){
				var raw = { type: "login", team: "o"};
				var data = JSON.stringify(raw);
				socket.send(data);
				$("#x").hide();
				$("#o").hide();
			});

			$("#again").click(function(){
				location.reload();
			});
		});
	</script>
</head>

<body>
	<div class="container">
		<div class="row">
			<h1 id="status" class="text-center">Welcome to TicTacToe game!</h1>

			<table id="field" class="table table-bordered auto">
				<tr> <td></td><td></td><td></td> </tr>
				<tr> <td></td><td></td><td></td> </tr>
				<tr> <td></td><td></td><td></td> </tr>
			</table>

			<div class="container">
				<button id="again" type="button" class="btn btn-primary btn-block"> Try again </button>
				<button id="x" type="button" class="btn btn-primary btn-block"> Play for X </button>
				<button id="o" type="button" class="btn btn-primary btn-block"> Play for O </button>

				<div class="col-xs-12" style="height:25px;"></div>
			</div>
		</div>
	</div>
</body>
</html>
